using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace WindowsApplication1
{
	/// <summary>
	/// okapi32 ժҪ˵
	/// </summary>
    
	class okapi32
	{
        public Int32 hBoard; //board handler
        public string lpdib;			//ɼĿ
        
        //дokapi32.hͷļ
        //2010-01-11 liu.p
        public const int OK_M10 = 1010;
        public const int OK_M10N = 1010;
        public const int OK_M10M = 1013;
        public const int OK_M10F = 1011;
        public const int OK_M10L = 1014;
        public const int OK_M10H = 1012;
        public const int OK_M20 = 1020;
        public const int OK_M2KC = 1021;

        public const int OK_M20H = 1022;
        public const int OK_M30 = 1030;
        public const int OK_M40 = 1040;
        public const int OK_M50 = 1050;
        public const int OK_M60 = 1060;
        public const int OK_M70 = 1070;
        public const int OK_M80 = 1080;
        public const int OK_M80K = 1081;

        //--new updated series
        public const int OK_M10A = 1210;
        public const int OK_M10B = 1213;                       //OK_M10M:1013
        public const int OK_M10C = 1214;                       //OK_M10L/N:1014
        public const int OK_M10D = 1215;
        public const int OK_M10K = 1218;                       //OK_M80K
        public const int OK_M11K = 1217;                       //


        public const int OK_M20A = 1222;                       //OK_M20H:1022
        public const int OK_M20B = 1223;                       //110M
        public const int OK_M20C = 1224;                       //160M
        public const int OK_M20D = 1225;                       //2050M

        public const int OK_M40A = 1240;                       //OK_M40:1041
        public const int OK_M40B = 1243;                       //110M
        public const int OK_M40C = 1244;                       //160M
        public const int OK_M40D = 1245;                       //205M

        public const int OK_M60A = 1260;                       //OK_M60:1060
        public const int OK_M60B = 1263;                       //110M
        public const int OK_M60C = 1264;                       //160M
        public const int OK_M60D = 1265;                       //205M

        public const int OK_M50A = 1250;
        public const int OK_M50K = 1258;
        public const int OK_M51K = 1257;

        //64 bits series
        public const int OK_DM20B = 1223;                      //140M
        public const int OK_DM20C = 1224;                      //160M
        public const int OK_DM20D = 1225;                     //205M

        //PCI_X seriesC
        public const int OK_XM20_140 = 1323;

        //Color series
        public const int OK_C20 = 2020;
        public const int OK_C20C = 2021;
        public const int OK_C30 = 2030;
        public const int OK_C32 = 2032;
        public const int OK_C33 = 2033;
        public const int OK_C30S = 2031;
        public const int OK_C40 = 2040;
        public const int OK_C50 = 2050;
        public const int OK_C70 = 2070;
        public const int OK_C80 = 2080;
        public const int OK_C80M = 2081;
        public const int OK_C82 = 2082;

        //RGB series
        public const int OK_RGB10 = 3010;
        public const int OK_RGB20 = 3020;
        public const int OK_RGB30 = 3030;

        //Monitor Control series
        public const int OK_MC10 = 4010;
        public const int OK_MC16 = 4016;
        public const int OK_MC20 = 4020;
        public const int OK_MC30 = 4030;

        //--new updated series
        public const int OK_C20A = 2220;
        public const int OK_C23A = 2221;
        public const int OK_C20B = 2223;
        public const int OK_C30A = 2230;
        public const int OK_C31A = 2231;
        public const int OK_C30B = 2233;
        public const int OK_C40A = 2240;
        public const int OK_C50A = 2250;
        public const int OK_C60A = 2260;
        public const int OK_C60B = 2263;
        public const int OK_C80A = 2280;
        public const int OK_C80K = 2288;

        public const int OK_RGB10A = 3210;
        public const int OK_RGB10B = 3213;

        public const int OK_RGB20A = 3220;
        public const int OK_RGB20B = 3223;
        public const int OK_RGB20C = 3224;

        public const int OK_RGB30A = 3230;
        public const int OK_RGB30B = 3233;
        public const int OK_RGB30C = 3234;

        public const int OK_MC10A = 4210;
        public const int OK_MC12A = 4212;
        public const int OK_MC16A = 4216;


        //---usb series
        public const int OK_USB20A = 5220;

        //---pc104+ series
        public const int OK_PC10 = 5210;

        //---cPCI series
        public const int OK_CPC16A = 5230;


        //---Ok sereis Camera
        public const int OK_AC1210 = 211210;
        public const int OK_AC1310 = 211310;

        public const int OK_SC1310 = 311310;


        //--error code

        public const int ERR_NOERROR = 0;           //no error
        public const int ERR_NOTFOUNDBOARD = 1;            //not found available ok board

        public const int ERR_NOTFOUNDVXDDRV = 2;           //not found ok vxd driver
        public const int ERR_NOTALLOCATEDBUF = 3;          //not pre-allocated buffer from host memory
        public const int ERR_BUFFERNOTENOUGH = 4;          //available buffer not enough requirment
        public const int ERR_BEYONDFRAMEBUF = 5;           //capture iamge size beyond buffer

        public const int ERR_NOTFOUNDDRIVER = 6;           //no driver found
        public const int ERR_NOTCORRECTDRIVER = 7;         //driver not correct

        public const int ERR_MEMORYNOTENOUGH = 8;          //memory not enough
        public const int ERR_FUNNOTSUPPORT = 9;            //the function not support
        public const int ERR_OPERATEFAILED = 10;           //something wrong with the operation

        public const int ERR_HANDLEAPIERROR = 11;          //the handle to okapi function wrong
        public const int ERR_DRVINITWRONG = 12;            //something wrong with driver initialize

        public const int ERR_RECTVALUEWRONG = 13;          //the rect set wrong
        public const int ERR_FORMNOTSUPPORT = 14;          //the form set not support by the board

        public const int ERR_TARGETNOTSUPPORT = 15;        //the target not support by this function

        public const int ERR_NOSPECIFIEDBOARD = 16;        //not found specified board correctly sloted

        //--format defines
        public const int FORM_RGB888 = 1;
        public const int FORM_RGB565 = 2;
        public const int FORM_RGB555 = 3;
        public const int FORM_RGB8888 = 4;
        public const int FORM_RGB332 = 5;
        public const int FORM_RGB8886 = 18;

        public const int FORM_YUV422 = 6;
        public const int FORM_YUV411 = 7;
        public const int FORM_YUV16 = 8;
        public const int FORM_YUV12 = 9;
        public const int FORM_YUV9 = 10;
        public const int FORM_YUV8 = 11;

        public const int FORM_GRAY888 = 12;
        public const int FORM_GRAY8888 = 13;
        public const int FORM_GRAY8 = 14;
        public const int FORM_GRAY10 = 15;
        public const int FORM_GRAY12 = 16;
        public const int FORM_GRAY16 = 17;



        //--mask command
        public const int MASK_DISABALE = 0;                //turn of mask
        public const int MASK_POSITIVE = 1;                //0 win clients visible, 1 video visible
        public const int MASK_NEGATIVE = 2;                //0 for video 1 for win client (graph)


        //--tv system standard
        public const int TV_PALSTANDARD = 0;               //PAL
        public const int TV_NTSCSTANDARD = 1;              //NTSC
        public const int TV_NONSTANDARD = 2;               //NON_STD
        public const int TV_HDTVSTANDARD = 3;              //HDTV_STD
        //public const int TV_SECAMSTANDARD = 3;             //SECAM

        //--HDTV sub mode
        public const int HDTV_480P = 1;                   //480 Lines Progressive scan
        public const int HDTV_720P = 2;                   //720 Lines Progressive scan
        public const int HDTV_1080I = 3;                   //1080 Lines Interlaced scan
        public const int HDTV_1080P = 4;                   //1080 Lines Interlaced scan


        public const int TV_PALMAXWIDTH = 768;
        public const int TV_PALMAXHEIGHT = 576;

        public const int TV_NTSCMAXWIDTH = 640;            //720
        public const int TV_NTSCMAXHEIGHT = 480;


        //-----defines lParam for get param
        public const int GETCURRPARAM = -1;

        //-----sub-function defines for wParam of SetVideoParam
        //wParam cab be one of the follow
        public const int VIDEO_RESETALL = 0;                 //reset all to sys default
        public const int VIDEO_SOURCECHAN = 1;
        // lParam=0,1.. Comp.Video; 0x100,101...to Y/C(S-Video), 0x200,0x201 to RGB Chan.Input
        public const int VIDEO_BRIGHTNESS = 2;               // LOWORD is brightness, for RGB exHiWord is channel (0:red, 1:green, 2:blue)
        public const int VIDEO_CONTRAST = 3;                 // LOWORD is contrast, for RGB exHiWord is channel (0:red, 1:green, 2:blue)
        public const int VIDEO_COLORHUE = 4;
        public const int VIDEO_SATURATION = 5;
        public const int VIDEO_RGBFORMAT = 6;                // when return low word  is code high word is bitcount
        public const int VIDEO_TVSTANDARD = 7;               // 0 PAL, 1 NTSC, 2 Non-stadard
        public const int VIDEO_SIGNALTYPE = 8;               // LOWORD 0 non-interlaced, 1 interlaced
        // exHiWord 0 no slot in field header, 1 yes
        public const int VIDEO_RECTSHIFT = 9;                // malelong (x,y)
        public const int VIDEO_SYNCSIGCHAN = 10;             // LOWORD 0:Red,1:Grn,2:Blue, 3:Sync;
        // exHiWord is source 0,1,..for RGB input,
        // 0x100,0x101,... for comp.video input
        // ( in this case LOWORD has not mean more)
        public const int VIDEO_AUXMONCHANN = 11;             // monitor video source chann on aux monitor
        public const int VIDEO_AVAILRECTSIZE = 12;           // exMakeLong(horz,vert)
        // horz available pixels per scan line and
        // vert available lines per frame
        public const int VIDEO_FREQSEG = 13;                 // set horz video frequency range
        // 0:Low(7.5~15MHz),  1:middle(15~30), 2:High(30~60)
        public const int VIDEO_LINEPERIOD = 14;              // line period (in 0.5 us) generated by board
        public const int VIDEO_FRAMELINES = 15;              // lines per frame  generated by board

        public const int VIDEO_MISCCONTROL = 16;             // miscellaneous control bits
        // b0:-satur, b1:- contr for c20, c30
        // b2:agc
        public const int VIDEO_ENABLEGRAPHS = 17;            // enable graph
        public const int VIDEO_GAINADJUST = 18;              // gain adjust
        public const int VIDEO_RECTSHIFTEX = 19;             //general video active rect shift,  makelong (x,y)
        //replace for VIDEO_RECTSHIFT



        //-----sub-function defines for wParam of SetCaptureParam
        //wParam cab be one of the follow
        public const int CAPTURE_RESETALL = 0;           //reset all to sys default
        public const int CAPTURE_INTERVAL = 1;
        public const int CAPTURE_CLIPMODE = 2;           //LOWORD: clip mode when video and dest rect not same size
        //exHiWord: if captrure odd and even field crosslly
        public const int CAPTURE_SCRRGBFORMAT = 3;       //when return, loword=code, exHiWord=bits
        public const int CAPTURE_BUFRGBFORMAT = 4;
        public const int CAPTURE_FRMRGBFORMAT = 5;
        public const int CAPTURE_BUFBLOCKSIZE = 6;       //lParam=MAKELONG(width,height)
        //if set it 0 (default), the rect set by user will be as block size
        public const int CAPTURE_HARDMIRROR = 7;         //bit0 x, bit1 y;
        public const int CAPTURE_VIASHARPEN = 8;         //sample via sharpen filter
        public const int CAPTURE_VIAKFILTER = 9;         //sample via recursion filter
        public const int CAPTURE_SAMPLEFIELD = 10;       //0 in field (non-interlaced), 1 in frame (interlaced), (0,1 are basic)
        //2 in field but keep expend row,3 in field but interlaced one frame
        //(2,4 can affect only sampllng field(frame) by field(frame) )
        //in 3 up-dn frame
        public const int CAPTURE_HORZPIXELS = 11;        // set max horz pixel per scan line
        public const int CAPTURE_VERTLINES = 12;         // set max vert lines per frame

        public const int CAPTURE_ARITHMODE = 13;         //arithmatic mode
        public const int CAPTURE_TO8BITMODE = 14;        //the mode of high (eg. 10 bits) converted to 8bit
        //exHiWord(lParam)=0: linear scale,
        //exHiWord(lParam)!=0:clip mode, LOWORD(lParam)=offset
        public const int CAPTURE_SEQCAPWAIT = 15;        // bit0 if waiting finished for functions of sequence capturing and playbacking
        //bit1 if waiting finished capture then call callback function

        public const int CAPTURE_MISCCONTROL = 16;       //miscellaneous control bits
        //bit0: 1: take one by one |okCapturByBuffer,okGetSeqCapture by interrupt control
        //bit1: 1: take last one   |

        public const int CAPTURE_TRIGCAPTURE = 17;       //set triggered capture, LOWORD cap no of fields, HIWORD delay fields after trigger
        public const int CAPTURE_TURNCHANNELS = 18;      //turn channel when sequence capture

        public const int SAMPLE_INFIELD = 0;             //in field (non-interlaced)
        public const int SAMPLE_INFRAME = 1;             //in frame of interlaced fields
        //the above two (0,1) are basic
        public const int SAMPLE_FIELDEXP = 2;            //in field but expend (keep expend row)
        public const int SAMPLE_UPDNFRAME = 3;           //in frame of up-downed fields
        public const int SAMPLE_FIELDINTER = 4;          //in field but interlaced to one frame

        //-----defines lParam for CAPTURE_CLIPMODE
        public const int RECT_SCALERECT = 0;
        public const int RECT_CLIPCENTER = 1;
        public const int RECT_FIXLEFTTOP = 2;
        //in condition video rect great than screen rect:
        //if RECT_SCALERECT video rect will be scaled to match screen rect if it can. else
        //video rect will be adjusted to match screen rect
        //(1: center, take center video rect  2: left-top fixed, take same size rect)


        //-----sub-function defines for lParam of GetSignalParam
        public const Int32 SIGNAL_VIDEOEXIST = 1;          //0 video  absent, 1 exist
        public const Int32 SIGNAL_VIDEOTYPE = 2;           //0 field, 1 interlaced
        public const Int32 SIGNAL_SCANLINES = 3;           //scan lines per frame
        public const Int32 SIGNAL_LINEFREQ = 4;            //line frequency
        public const Int32 SIGNAL_FIELDFREQ = 5;           //frame frequency
        public const Int32 SIGNAL_FRAMEFREQ = 6;           //frame frequency
        public const Int32 SIGNAL_EXTTRIGGER = 7;          //extern trigger status
        public const Int32 SIGNAL_FIELDID = 8;             //Field ID 0 odd, 1 even
        public const Int32 SIGNAL_VIDEOCOLOR = 9;          //color(1) or B/W(0)


        //-----sub-function defines for lEvent of WaitSignalEvent
        public const int EVENT_FIELDHEADER = 1;          //field header
        public const int EVENT_FRAMEHEADER = 2;          //frame header
        public const int EVENT_ODDFIELD = 3;             //odd field come
        public const int EVENT_EVENFIELD = 4;            //even field come
        public const int EVENT_EXTTRIGGER = 5;           //extern trigger come,
        //(exHiWord(lEvent) is index)

        //-----sub-function defines for lParam of PutSignalParam
        public const int PUTSIGNAL_TRIGGER = 1;          //put trigger signal, 1 trigger


        //-----sub-function defines for lParam of okSetConvertParam
        public const ushort CONVERT_RESETALL = 0;          //reset all to sys default
        public const ushort CONVERT_FIELDEXTEND = 1;        //field extend
        public const ushort CONVERT_PALETTE = 2;            //set convert palette (just for 8 to 24 or 32)
        //lParam=0: restore system default, >0: new palette pointer
        public const ushort CONVERT_HORZEXTEND = 3;         //horzental extend (integer times)
        public const ushort CONVERT_HORZSTRETCH = 4;        //horzental stretch (arbitrary number times)
        public const ushort CONVERT_MIRROR = 5;             //x and y mirror
        public const ushort CONVERT_UPRIGHT = 6;            //up to righ(=1)(rotate right 90 D) or left (=2) (rotate left 90 D

        //field extend mode
        public const int FIELD_JUSTCOPY = 0;         //just copy row by row
        public const int FIELD_COPYEXTEND = 1;       //copy one row and expend one row (x2)
        public const int FIELD_INTERLEAVE = 2;       //just copy odd(1.) rows (/2)
        public const int FIELD_INTEREXTEND = 3;      //copy one odd row and expend one row
        public const int FIELD_COPYINTERPOL = 4;     //copy one odd row and interpolate one row
        public const int FIELD_INTERINTERPOL = 5;    //copy odd row and interpolate even row

        public const int FIELD_INTEREVEN = 6;        //just copy even(2.) rows (/2)
        public const int FIELD_INTEREXTEVEN = 7;     //copy one even row and expend one row
        public const int FIELD_JUSTCOPYODD = 8;      //just copy odd rows to odd rows
        public const int FIELD_JUSTCOPYEVEN = 9;     //just copy even rows to even rows
        public const int FIELD_ODDEVENCROSS = 10;    //copy odd and even crossly


        //just for the case without bit converting

        //-----sub-function defines for wParam of okBeginEncode and okBeginDecode
        public const int CODE_JPEG = 1;
        public const int CODE_MPEG2 = 2;
        public const int CODE_MJPG = 3;
        public const int CODE_MPEG4 = 4;
        public const int CODE_JPEG2 = 5;

        //-----defines for several target we can support
        //public structdef LPARAM  TARGET;

        public const Int32 BUFFER = 1;           //Buffer(physical) allocated from host memory
        public const Int32 VIDEO = 0;            //Video source input to the board
        public const Int32 VSCREEN = -1;          //Screen supported by VGA
        public const Int32 FRAME = -2;           //Frame buffer on the board
        public const Int32 MONITOR = -3;         //Monitor supported by (D/A) TV standard


        //public const int SEQFILE = &H5153;             //SQ
        //public const int BMPFILE = &H4D42;             //BM

        //public const int BLKHEADER = &H4B42;           //BK
        //public const int BMPHEADER = &H4D42;           //BM
        //public const int BUFHEADER = &H4642;           //BF


        //-----------struct defines---------------

        public const int LF_FACESIZE = 32;
        

        
        ////--app user used struct
        

        [StructLayout(LayoutKind.Sequential)]
        unsafe public struct OKDEVTYPE  
        {
            Int32 iBoardTYPECode;    //ok image device public struct code (e.g. 2030(capture card), 201100(camera))
            Int32 iBoardIdentCode;   //ok image device identity code (e.g. 2130)
            Int32 iBoardRankCode;    //ok image device model code 0,1,..
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 256)]
            string dName; //ok image device name (eg."OK_M20H", "OK_AM1100"...)
        }    //128 bytes
        

        public struct LOGFONT
        {
            public Int32 lfHeight;
            public Int32 lfWidth;
            public Int32 lfEscapement;
            public Int32 lfOrientation;
            public Int32 lfWeight;
            public byte lfItalic;
            public byte lfUnderline;
            public byte lfStrikeOut;
            public byte lfCharSet;
            public byte lfOutPrecision;
            public byte lfClipPrecision;
            public byte lfQuality;
            public byte lfPitchAndFamily;

            public Int32 lfFaceName1; //as char[32]
            public Int32 lfFaceName2;
            public Int32 lfFaceName3;
            public Int32 lfFaceName4;
        }
        public struct tpBlockInfo
        {
            int iType;      //=BK or SQ, BM
            //struct _blocksize;
            int iWidth;    //width
            int iHeight;     //height
            int iBitCount;    //pixel bytes iBitCount
            int iFormType;    //rgb format public struct, need to fill when RGB565 or RGB 555
            int lBlockStep;  //block stride (step to next image header)
            int iHiStep;     //exHiWord of block stride
            int lTotal;       //frame num
            int iHiTotal;     //exHiWord of total
            int iInterval;    //frame interval

            long lpBits;// image data pointer / file path name
            long lpExtra; // extra data (like as palette, mask) pointer
        }
        public struct tpDibInfo              //file info for seq
        {
            long lpbi;            //bitmap info
            long lpdib;           //dib data
            long hwndPlayBox;     //1 replaying, 0 quit
            long iCurrFrame;   //current frame in buffer
            long iReserved;
        }

        public struct RECT
        {
            public Int32 Left;
            public Int32 Top;
            public Int32 Right;
            public Int32 Bottom;
        }
        public struct tpTextMode
        {
            public Int32 dwForeColor;    // forecolor, see macro RGB in win
            public Int32 dwBackColor;     // backcolor, see macro RGB in win
            public Int32 dwSetMode;       // 0:FULLCOPY, 1: FULLXOR
            public Int32 wFrameNo;     // place which frame of target
            public Int32 wReserved;    // no used
        }
        public struct tpSeqInfo //file info for seq
        {
            int iType;   //=SQ or BM
            //struct _blocksize;
            int iWidth;      //width
            int iHeight;     //height
            int iBitCount;   //pixel bytes iBitCount
            int iFormType;   //rgb format public struct, need to fill when RGB565 or RGB 555
            int lBlockStep; //block stride (step to next image header)
            int iHiStep;    //exHiWord of block stride

            int lTotal;     //frame num
            int iHiTotal;    //exHiWord of total
            int iInterval;  //frame interval
        }
        //image file block size
        public struct tpBlockSize
        {
            int iWidth;     //width
            int iHeight;     //height
            int iBitCount;   //pixel bytes iBitCount
            int iFormTYPE;   //rgb format public struct, need to fill when RGB565 or RGB 555
            int lBlockStep;     //block stride (step to next image header)
            //need to fill when treat multi block else set 0
        }
        public tpBlockSize BLOCKSIZE;

        //image block info
        
        public tpBlockInfo BLOCKINFO;
        public long LPBLOCKINFO;
        public tpBlockInfo blkUse;

        //sequence file info
        
        public tpSeqInfo SEQINFO;

        //for replay
       
        public long LPDIBINFO;
        public long lpDibPlay;

        //---image size------
        public struct tpImageSize
        {
            long dwWidth;
            long dwHeight;
            long dwBitCount;
            long dwTotal;
        }
        public tpImageSize IMAGESIZE;
        public long LPIMAGESIZE;

        //--jpeg set params
        public struct tpJpegParam
        {
            long dwSize;      // the size of this strcut
            long lpstrName;   //must be NULL if not use
            long dwQuality;
            long dwReserved1;
        }
        public tpJpegParam JPEGPARAM;
        public long LPJPEGPARAM;

        //---set text mode----
        
        public tpTextMode SETTEXTMODE;


        public const int FULLCOPY = 0;                 //copy full text region into target
        public const int FULLXOR = 1;                  //xor full text region and target
        public const int COPYFONT = 2;                 //just copy fonts strokes to target
        public const int XORFONT = 3;                  //just xor fonts strokes and target



        //'lWhich defined as the follow
        public const int STATICVXD = 1;
        public const int INSTNTDRV = 2;
        public const int ALLOCBUFFER = 3;
        public const int MEMBLOCKSIZE = 4;
        public const int MEMBLOCKCOUNT = 5;
        public const int UNREGISTER = 6;


        public const int PROGRAM = 1;
        public const int VERSION = 2;
        public const int PREFIX = 3;
        public const int COMPANY = 4;
        public const int TELFAX = 5;
        public const int WEBEMAIL = 6;


        //'-----defines wParam in okSetAudioParam
        public const int AUDIO_RESETALL = 0;            ////reset all to sys default
        public const int AUDIO_SAMPLEFRQ = 1;           ////Sample rate, in samples per second
        public const int AUDIO_SAMPLEBITS = 2;           //'Bits per sample
        public const int AUDIO_INVOLUME = 3;            ////Audio input gain control
        public const int AUDIO_CALLINTERVAL = 4;         //'callback after interval times


        //'--6. stream section routines--------------

        public const int NONE = 0;

        //'-----defines wParam in okSetStreamParam

        public const int STREAM_RESETALL = 0;            //'reset all to sys default
        public const int STREAM_RESOLUTION = 1;         //'Sample resolution, 0=D1,1=2/3D1,2=1/2D1,3=SIF
        public const int STREAM_BITRATEMODE = 2;         //'Bit Rate mode 0: VBR(Variable BR), 1: CBR(Constant)
        public const int STREAM_MAXBITRATE = 3;          //'Max Bit Rate, it is BR for CBR, it is max BR for VBR
        public const int STREAM_CALLINTERVAL = 4;        //'callback after interval times

		//-------------c++c#ת ----------
		//LONG            long
		//HANDLE          System.IntPtr
		//LPARAM          long
		//BOOL            long
		//LPSTR           char *
		//LPRECT          UNKNOW
		//HWND            System.IntPtr
		//WORD            System.UInt16
		//DWORD           System.UInt32
		//TARGET          long
		//LPBYTE          byte *   ??maybe string??
		//WPARAM          System.UInt32
		//------ okapi32 functions list -----------
        public Int32 tes() 
        {
            return 0;
        }

        [DllImport("okapi32.dll")]
        unsafe static extern public System.IntPtr okOpenBoard(Int32 *lIndex); //okLockBoard

        [DllImport("okapi32.dll")]
        public static extern Boolean okCloseBoard(Int32 hBoard);
        
        [DllImport("okapi32.dll")]
        public static extern Int32 okCaptureTo(Int32 hBoard, Int32 dest, Int32 start, Int32 lParam);

        [DllImport("okapi32.dll")]
        public static extern Int32 okGetLastError();

        [DllImport("okapi32.dll")]
        public static extern Int32 okGetBufferSize(Int32 hBoard, Int32 lpLinear, Int32 dwSize);
        //'get base address and size of pre-allocated buffer,
        //'if success return the max. frame num in which can be store according to current set
        //'else return false;
        /// <summary>
        /// //////////////////////////////////
        /// </summary>
        /// <param name="iItem"></param>
        /// <param name="lpString"></param>
        /// <param name="iSize"></param>
        /// <returns></returns>
        [DllImport("okapi32.dll")]
        public static extern long okGetProgramInfo(Int32 iItem, byte lpString, Int32 iSize);
        //'get program info
        [DllImport("okapi32.dll")]
        public static extern long okGetTypeCode(Int32 hBoard, byte lpBoardName);
        //'return type code and name of specified handle

        //Declare Function okGetSlotBoard Lib "okapi32.dll" (lpBoardInfo As Long) As Integer
        //'Query all Ok boards available in PCI bus, return total number
        [DllImport("okapi32.dll")]
        public static extern long okGetAvailBuffer(Int32 lpLinear, Int32 dwSize);
        //'Get free meomery buffers pre-allocated .
        //'call it when user hope to access buffer directly or lock for one board
        [DllImport("okapi32.dll")]
        public static extern int okSetNTDriver(Int32 bCmd);
        //'bCmd=0: check if nt driver installed.
        //'=1: install nt driver
        //'=2: remove nt driver
        [DllImport("okapi32.dll")]
        public static extern int okSetStaticVxD(Int32 lMode);
        //'lMode=0: check if static vxd registered.
        //'=1: create static vxd register
        //'=2: delete static vxd register//////////////////////////////////////////////////////////

        [DllImport("okapi32.dll")]
        public static extern IntPtr okGetBufferAddr(Int32 hApi, Int32 iNoFrame);//sub
        //get base address of specified frame No. in BUFFER
        //if success return the linear base address
        //else return false;
        [DllImport("okapi32.dll")]
        unsafe public static extern Int32 okGetTargetInfo(Int32 hApi, Int32 tgt, Int32 iNoFrame, short* wid, short* ht, Int32* stride);
      
        //get target info include base address, width, height and stride specified frame No.
        //if success return the linear base address and other infos, else return false;



        //set rect and capture
        [DllImport("okapi32.dll")]
        unsafe public static extern long okSetTargetRect(Int32 hBoard, Int32 target, RECT* lpTgtRect);
        //set target (VIDEO, SCREEN, BUFFER, FRAME)capture to or from
        //if Rect.right or .bottom) are -1 , they will be filled current value
        //special note for target=BUFFER:
        //if never set CAPTURE_BUFBLOCKSIZE, the block size(W,H) of buffer will be changed
        //according to size of right x bottom of lpRect, else the size will not changed
        //if success return max frames this target can support, else return <=0
        [DllImport("okapi32.dll")]
        public static extern Boolean okSetToWndRect(Int32 hBoard, Int32 hwnd);
        //set client rect of hwnd as screen rect

        [DllImport("okapi32.dll")]
        public static extern Boolean okCaptureSingle(Int32 hBoard, Int32 dest, Int32 lStart);
        //capture video source to target which can be BUFFER, SCREEN, FRAME, MONITOR
        //start(o based).if success return 1, if failed return 0, if not support target -1
        //when this function sent command to grabber, then return immediately not wait to finish.
        //this function same as okCaptureTo(hBoard, Dest, wParam, 1);
        [DllImport("okapi32.dll")]
        public static extern Boolean okCaptureActive(Int32 hBoard, Int32 dest, Int32 lStart);
        //capture continuous active video to same position in target which can be BUFFER, SCREEN, FRAME, MONITOR
        //start(o based).if success return 1, if failed return 0, if not support target -1
        //when this function sent continuous command to grabber, then return immediately
        //but note that some card like RGB30. when target is SCREEN, this function is a thread.
        //this function same as okCaptureTo(hBoard, Dest, wParam, 0);
        [DllImport("okapi32.dll")]
        unsafe public static extern Int32 okCaptureSquence(Int32 hBoard, Int32 lStart, Int32 lNoFrame);
        //capture continuous active video to same position in target which can be BUFFER, SCREEN, FRAME, MONITOR
        //start(o based).if success return 1, if failed return 0, if not support target -1
        //when this function sent continuous command to grabber, then return immediately
        //but note that some card like RGB30. when target is SCREEN, this function is a thread.
        //this function same as okCaptureTo(hBoard, Dest, wParam, 0);
        [DllImport("okapi32.dll")]
        public static extern Boolean okCaptureThread(Int32 hBoard, Int32 dest, Int32 lStart, Int32 lParam);
        //capture sequencely video to target which can be BUFFER, SCREEN, FRAME, MONITOR
        //start(o based). lParam>0: number of frame to capture to,
        //if lParam > total frames in BUFER, it will loop in rewind mode(i%total)
        //if lParam=-N mean it loop in buffer of N frame infinitely until call okStopCapture,
        //when -1 mean loop in all buffer.
        //return max num frame can be stored in the target if success,
        //return 0 if failed(eg. format not matched). -1 not support target
        //this call will create a thread to manage to capture sequencely then
        //return immediately not wait to finish. This thread will callback if need
        //this function same as okCaptureTo(hBoard, Dest, wParam, n);
        //but it is not same, when n=1 this function is also a thread and still support callback
        [DllImport("okapi32.dll")]
        public static extern Int32 okCaptureToScreen(Int32 hBoard);
        //Start to capture to screen (video real-time display on screen) and return immediately
        //this is just a special routine of okCaptureTo(hBoard,SCREEN,0,0)


        [DllImport("okapi32.dll")]
        public static extern Boolean okPlaybackFrom(Int32 hBoard, Int32 src, Int32 start, Int32 lParam);
        //playback on monitor from target which can be BUFFER, FRAME
        //start(o based), lParam>0: number of frame to capture to, =0: cont. mode
        //if lParam > total frames in BUFER, it will loop in rewind mode (i%total)
        //if lParam=-1 mean it loop infinitely until call okStopCapture
        //return max num frame be stored in the target if success,
        //return 0 if wrong. -1 not support target
        //this call will return immediately not wait to finish.
        //

        //get status and stop capture
        [DllImport("okapi32.dll")]
        public static extern Int32 okGetCaptureStatus(Int32 hBoard, bool bWait);
        //query capturing status, if bWait then wait to finish capturing, else return immediately.
        //return 0 if finished, if cont. mode capturing return target capture to
        //(which include SCREEN -1, FRAME -2, MONITOR -3)
        //if capturing to/from BUFFER or file, return the frame No.(1 based) being capturing
        [DllImport("okapi32.dll")]
        public static extern Boolean okStopCapture(Int32 hBoard);
        //Stop capturing to or playback from SCREEN, BUFFER or other targets
        //return target just captured to or from.
        //if capturing to/from BUFFER or file, return the frame No.(1 based) being capturing

        [DllImport("okapi32.dll")]
        public static extern Int32 okGetSeqCapture(Int32 hApi, Int32 start, Int32 count);
        //get current frame no. of sequence capturing to buffer
        //start: set buffer no. to use, effecting only count==0
        //count: count no. to catpure, start from count=0
        
       

        //capture by to /from
        [DllImport("okapi32.dll")]
        unsafe public static extern Int32 okCaptureByBuffer(Int32 hBoard, Int32 dest, Int32 start, Int32 num);
        //Any(vb)
        //capture sequence images to dest by way of two frame buffers (in BUFFER),
        //the frame size and format is taken as same as current config of BUFFER
        //if dest is file name which can be .seq or .bmp (will generate multi bmp files)
        //dest can be also a user memory pointer or a BLOCKINFO pointer (with user memory pointer)
        //retrun true immediately if success. num should be great than 0

        [DllImport("okapi32.dll")]
        public static extern Boolean okCaptureByBufferEx(Int32 hBoard, Int32 fileset, Int32 dest, Int32 start, Int32 num);
        // all are same as okCaptureByBuffer except for fileset which is quality when to jpg file
        [DllImport("okapi32.dll")]
        public static extern Boolean okPlaybackByBuffer(Int32 hBoard, Int32 src, Int32 start, Int32 num);
        //playback sequence images on monitor from src by way of two frame buffers (in BUFFER)
        //the size and format of BUFFER will be changed to same as src
        //src can be a file name which may be .seq or .bmp (first orderd bmp files)
        //'src can be also a BLOCKINFO pointer (with infos of user memory pointer,size and format)
        //if src is just user memory pointer, this function will think its block size and format
        //are same as current config of BUFFER (in this case can not support loop function).
        //retrun true immediately if success
        //if num is great than the true frame number in src, it will loop back
        //if num=-1 mean it will loop infinitely until call okStopCapture

        //set and get params
        [DllImport("okapi32.dll")]
        public static extern Int32 okSetVideoParam(Int32 hBoard, Int32 wParam, Int32 lParam);
        //----set video param sub-function defines
        //set video param and return previous param;
        //if input lParam=-1, just return previous param
        //if not support return -1, if error return -2
        [DllImport("okapi32.dll")]
        public static extern Int32 okSetCaptureParam(Int32 hBoard, Int32 wParam, Int32 lParam);
        //set capture param and return previous param;
        //if input lParam=-1, just return previous param
        //if not support return -1, if error return -2


        //transfer and convert rect
        [DllImport("okapi32.dll")]
        public static extern Int32 okReadPixel(Int32 hBoard, Int32 src, Int32 start, Int32 x, Int32 y);
        //read value of one pixel specified (x,y) in frame start of src (SCREEN, BUFFER, FRAME...)
        //return is this pixel value, it may be with bits 8,16,24,or 32 depend on the src's format
        [DllImport("okapi32.dll")]
        public static extern Int32 okWritePixel(Int32 hBoard, Int32 tgt, Int32 start, Int32 x, Int32 y, Int32 lValue);
        //write value into specified (x,y) in the frame start of tgt (SCREEN, BUFFER, FRAME...)
        //
        [DllImport("okapi32.dll")]
        public static extern Int32 okSetConvertParam(Int32 hBoard, ushort wParam, Int32 lParam);
        //set convert param for for function okConvertRect
        //if not support return -1, if error return -2
        [DllImport("okapi32.dll")]
        public static extern Int32 okReadRect(Int32 hApi, Int32 src, Int32 start, byte lpbuf);
        //read data into lpBuf from rect(set previous) in frame start of dst (SCREEN, BUFFER, FRAME)
        //the data in lpBuf stored in way row by row
        //if src not supported return -1, if failed return 0,
        //return -1 if not support, return 0 failed,
        //if success return data length read in byte
        //if lpBuf=NULL, just return data length to read
        [DllImport("okapi32.dll")]
        public static extern Int32 okWriteRect(Int32 hApi, Int32 dst, Int32 start, byte lpbuf);
        //write data in lpBuf to rect(set previous) of dst (SCREEN, BUFFER, FRAME)
        //the data in lpBuf stored in way row by row
        //return -1 if not support, return 0 failed,
        //if success return data length written in byte
        [DllImport("okapi32.dll")]
        public static extern Int32 okReadRectEx(Int32 hApi, Int32 src, Int32 start, byte lpbuf, Int32 lParam);
        //read data into lpBuf from rect(set previous) in frame start of dst (SCREEN, BUFFER, FRAME)
        //the data in lpBuf stored in way row by row
        //if src not supported return -1, if failed return 0,
        //return -1 if not support, return 0 failed,
        //if success return data length read in byte
        //if lpBuf=NULL, just return data length to read
        //LOWORD(lParamis form code for bits of lpBuf (e.g.FORM_GRAY8if it is 0 mean: as same as src
        //exHiWord(LParam) is the mode of taking channels. mode=0 take all, =1 red, =2 green, =3 blue;
        [DllImport("okapi32.dll")]
        public static extern Int32 okWriteRectEx(Int32 hApi, Int32 dst, Int32 start, byte lpbuf, Int32 lParam);
        //write data in lpBuf to rect(set previous) of dst (SCREEN, BUFFER, FRAME)
        //the data in lpBuf stored in way row by row
        //return -1 if not support, return 0 failed,
        //if success return data length written in byte
        //LOWORD(lParamis form code for bits of lpBuf (e.g.FORM_GRAY8if it is 0 mean: as same as dst
        //exHiWord(LParam) is the mode of taking channels. mode=0 take all, =1 red, =2 green, =3 blue;
        [DllImport("okapi32.dll")]
        public static extern Int32 okTransferRect(Int32 hBoard, Int32 dest, Int32 iFirst, Int32 src, Int32 iStart, Int32 lNum);
        //transfer source rect to dest rect (here target can be SCREEN, BUFFER, FRAME, also BLOCKINFO point to user memory)
        //if total in dest or src less than lNum, it will rewind to begin then continue
        //this function transfer in format of src, that means it don't convert pixel bits if dst and src are not same
        //if src or dst not supported return -1, if failed return 0,
        //if success return data length of one block image in byte
        [DllImport("okapi32.dll", EntryPoint = "okConvertRect", CharSet = CharSet.Auto, CallingConvention = CallingConvention.StdCall)]
        public unsafe static extern Int32 okConvertRect(Int32 hApi, Int32 dst, Int32 first, Int32 src, Int32 start, Int32 no);
        //transfer source rect to dest rect (here target can be SCREEN, BUFFER, FRAME, also BLOCKINFO point to user memory)
        //if total in dest or src < lNum, it will rewind to begin then continue
        //this function convert to pixel foramt of dst if dst has not same bits format as src
        //if src or dst not supported return -1, if failed return 0,
        //if success return image size of one block in pixel
        [DllImport("okapi32.dll")]
        public static extern Int32 okConvertRectEx(Int32 hDstBoard, Int32 dst, Int32 first, Int32 hSrcBoard, Int32 src, Int32 start, Int32 no);
        //same as the above function okConvertRect except with src handle
        [DllImport("okapi32.dll")]
        public static extern Boolean okUnifyFields(Int32 hBoard, Int32 target, Int32 start);
        //
        [DllImport("okapi32.dll")]
        public unsafe static extern Boolean okSetTextTo(Int32 hBoard, Int32 target, RECT* lpRect, LOGFONT* lfLogFont, tpTextMode* textmode, Int32 lpString, Int32 lLength);
        //set text into the image of specified target
        //target can be SCREEN, BUFFER, FRAME, also BLOCKINFO
        //lpRect: just use its (left,top) to points start posision
        //lfLogFont: windows font definition, see window's document
        //textMode: specify forecolor, backcolor and set mode
        //lpString, lLength: text string and it's length

        [DllImport("okapi32.dll")]
        public static extern Int32 okDrawEllipsTo(Int32 hBoard, Int32 target, Int32 lStart, RECT lpRect, Int32 iForeColor);
        //draw a ellips into specified target
        //target can be SCREEN, BUFFER, FRAME, also BLOCKINFO
        //lpRect: specify the rect region of expected ellips
        //iForeColor: draw value on to target
        //return the pixel count of ellips
        [DllImport("okapi32.dll")]
        public static extern Int32 okCreateDCBitmap(Int32 hBoard, Int32 target, Int32 hDCBitmap);
        //create a memory DC compatible with windows's GDI, draw graphic and text etc. with GDI functions
        //target can be SCREEN, BUFFER, FRAME, also BLOCKINFO
        //hDCBitmap: return a handle with which we can map the graphics on the memory DC
        //to our target.
        //return the memory DC with which you can use windows"s GDI functions
        [DllImport("OKAPI32.dll")]
        public static extern Int32 okMapDCBitmapTo(Int32 hDCBitmap, Int32 lStart);
        //map the graphics of memory DC created by okCreateDCBitmap into specified target
        //hDCBitmap: the handle created by okCreateDCBitmap
        [DllImport("okapi32.dll")]
        public static extern Boolean okFreeDCBitmap(Int32 hDCBitmap);
        //free the allocated resource by okCreateDCBitmap
        //hDCBitmap: the handle created by okCreateDCBitmap

        [DllImport("okapi32.dll")]
        unsafe public static extern Boolean okGetImageDevice([In, Out]OKDEVTYPE lpOkDevInfo, Int32* lParam);

        //get and put signals
        [DllImport("okapi32.dll")]
        public static extern Int32 okGetSignalParam(Int32 hBoard,Int32 wParam);
        //Get specified param of video signal source
        //if not support return -1, if error return -2, else return param
        [DllImport("okapi32.dll")]
        public static extern Int32 okWaitSignalEvent(Int32 hBoard, Int32 wParam, Int32 lMilliSecond);
        //Wait specified signal come
        //lMilliSecond is time-out time in milliseconds for to wait
        //if lMilliSecond is zero, the function returns current state immediately
        //if lMilliSecond is INFINITE(-1) wait forever until event come
        //return -1 not support, 0 speicfied signal not come, 1 come

        [DllImport("okapi32.dll")]
        public static extern Int32 okPutSignalParam(Int32 hBoard, Int16 wParam, Int32 lParam);
        //put specified signal param
        //if not support return -1, if error return -2,

        //treat callback functions
        [DllImport("okapi32.dll")]
        public static extern Boolean okSetSeqProcWnd(Int32 hBoard, Int32 hwndMain);
        //set proc hwnd for receive message about sequence capture


        [DllImport("okapi32.dll")]
        public static extern Boolean okSetSeqCallback(Int32 hBoard, BeginCapture BeginProc, Display SeqProc, EndCapture EndProc);
        //set callback function for multi-frame capturing function
        //(which are okCaptureTo, okCaptureFrom,okCaptureToFile, okCaptureFromFile)
        //see follow

        //BOOL    CALLBACK BeginProc(HANDLE hBoard);//user defined callback function
        //callback this function before to capture
        //BOOL    CALLBACK SeqProc(HANDLE hBoard, Int32 No);//user defined callback function
        // callback this function after finish capturing one frame
        // No is the number(0 based) frame just finished or being playbacked.
        //BOOL    CALLBACK EndProc(HANDLE hBoard);//user defined callback function
        // callback this function after end capturing

        //save and load files
        [DllImport("okapi32.dll")]
        public static extern Int32 okSaveImageFile(Int32 hBoard, Int32 szFileName, Int32 first, Int32 target, Int32 start, Int32 num);
       //here target can be BUFFER, SCREEN, FRAME or user buffer pointor
        //1.if ext name=".bmp":
        //create new file and than save one frame in start position of target as bmp file
        //
        //2.if ext name=".seq":
        //save no frame from (start) in target into (first) frame pos in seq(sequence) file in sequencely.
        //if the file already exist the function will not delete it, that mean old contents in the file will be kept.
        //So if you want create a new seq file with a existed file name you must delete before this call .
        //
        [DllImport("okapi32.dll")]
        public static extern Int32 okLoadImageFile(Int32 hBoard, String szFileName, Int32 first, Int32 target, Int32 start, Int32 num);
        //here target can be BUFFER, SCREEN, FRAME or user buffer pointor
        //1.if ext name=".bmp":
        //load one frame into start position of target from bmp file
        //
        //2.if ext name=".seq":
        //load no frame into (start) in target from (first) frame pos in seq(sequence) file in sequencely.

        //load and save config files with all parameters
        [DllImport("okapi32.dll")]
        public static extern Boolean okSaveConfigFile(Int32 hBoard, String szFileName);
        //save all current parameters set to specified config file (*.okf)
        [DllImport("okapi32.dll")]
        public static extern Boolean okLoadConfigFile(Int32 hBoard, String szFileName);
        //load specified config file to set current all paramters


        //apps setup dialog
        [DllImport("okapi32.dll")]
        public static extern Boolean okOpenSetParamDlg(Int32 hBoard, Int32 hParentWnd);
        //dialog to setup video param
        [DllImport("okapi32.dll")]
        public static extern Boolean okOpenSeqCaptureDlg(Int32 hBoard, Int32 hParentWnd);
        //dialog to capture sequence image
        [DllImport("okapi32.dll")]
        public static extern Int32 okOpenReplayDlg(Int32 hBoard, Int32 hwnd, Int32 src, Int32 total);

		

		//--9. others--------------

		public okapi32()
		{ 
			
			//
			// TODO: ڴ˴ӹ캯߼
			//
		}	
		
	}
}

